#define MAIN

#include "pixt.h"
#include "patchlevel.h"

/* 
** J. Michael Flanery, MIPS Computer Systems
** 15851 North Dallas Parkway
** Dallas, TX 75248
**
** (214) 770-7979
** 
** Email: flanery@mips.com
**
** This represents an incomplete endeavor at a portable Pixmap editor.
** Use at your own risk. Please send interesting comments and accolades
** to the addresses above. 
**
** Copyright 1990 J. Michael Flanery
**
** Permission to use, copy, modify, and distribute this software and its
** documentation for any purpose and without fee is hereby granted, provided
** that the above copyright notice appear in all copies and that both that
** copyright notice and this permission notice appear in supporting
** documentation, and that the name of J. Michael Flanery not be used 
** in advertising or publicity pertaining to distribution of the software 
** without specific, written prior permission.  J. Michael Flanery makes 
** no representations about the suitability of this software for any 
** purpose.  It is provided "as is" without express or implied warranty.
**
**
*/

#if !defined(lint) && !defined(SABER)
static char rcsid[] = "$Revision: pixt by J. Michael Flanery; Revision 1.0 $";
#endif

Boolean Virgin = True;
Colormap cmap;
long PixmapBackground ;
int dAreaW, dAreaH;
int SWinWidth, SWinHeight;
int ColorChangeMode = 0 ; /* the flag for determining whether or not we
			   * are selecting colors for a global change
			   */

int NumRowSegs, NumColSegs;
int DrawState = NOOP;
Boolean FirstPoint = True;

static XrmOptionDescRec cl_options[] = {
	{"-size", "*size", XrmoptionSepArg, (caddr_t)NULL},
	{"-s",    "*size", XrmoptionSepArg, (caddr_t)NULL},
};

typedef struct {
	String size;
} PixEditData, *PixEditDataPtr;
PixEditData resdata;

static XtResource resources [] = {
	{ "size", "Size", XtRString, sizeof(caddr_t),
	  XtOffset(PixEditDataPtr, size), XtRString, "60x60" }
};


Visual *visual;
Widget mainBB;
Widget pixView[2];
Widget fileSB;

XColor xc;

void exitCB();
void DrawGrid();
void KeyBtnCB();
void exposeCB();
void pixExposeCB();
void selectColorCB();
void MouseMotionCB();
void FileCB();
void UnFileCB();
void CancelFileCB();
void killMessage();
void inDialogCancelCB();
void inDialogOKCB();
Pixel str2pix();
unsigned long CurrentColor;

main(argc,argv)
unsigned int argc;
char **argv;
{
	Widget mainWindow;
	Widget workRegion;
	Widget menuBar;
	Widget dArea;
	Widget gridBtn;
	Widget exitBtn;
	Widget gridFrame;
	Widget cb;
	Widget pixViewSW;
	Arg args[10];
	register int i, n;
	int row, col;
	int PixelNumber;
	char str[30];
	char width[4], height[4];
	char *gstr;
	Dimension da_width;
	XWindowAttributes winatts;
	XtAppContext app;
	Widget dialog;
	XmString xmstr;
	XtInputMask inputMask;


	ColorMatch = True;
	FileState = NOOP;

	/*
	toplevel = XtInitialize("main","Pixt",cl_options,
			XtNumber(cl_options),&argc,argv);
	*/
	toplevel = XtAppInitialize(&app,"Pixt",cl_options,
			XtNumber(cl_options),
			&argc, argv,
			(String)NULL, (ArgList)NULL, 0);


	xmstr = XmStringCreateSimple("Starting up, please wait.");
	dialog = XmCreateMessageDialog(toplevel, "dialog", NULL, 0);
	XtVaSetValues(dialog, XmNmessageString, xmstr, NULL);
	XmStringFree(xmstr);
	/*
	** I attempted several different techniques for getting this
	** dialog up and readable before the rest of the stuff get's
	** going, but was never successful.  Perhaps it's the Mips
	** implementation.  If so, it might work on other machines.
	** Just for grins, you my try uncommenting the two lines below
	** to see if you can get a "busy working" dialog up...
	** XtManageChild(dialog);
	** ForceUpdate(dialog,app);
	*/
	printf("Starting pixt takes some time, please wait...\n");


	XtGetApplicationResources(toplevel, &resdata, resources, 
			XtNumber(resources), NULL, 0);


	/* now, get the width and height out of the geometry spec... */
	gstr = strchr(resdata.size,'x');
	strncpy(width,resdata.size,strlen(resdata.size)-strlen(gstr));
	strcpy(height,++gstr);
	NumRows = atoi(height);
	NumCols = atoi(width);
	RegionOp = NOOP;
	ImageType = PIX;
	ImageOp  = READ;

	NumRowSegs = NumRows + 1;
	NumColSegs = NumCols + 1;

	/*
	** initialize the global region variable. the 0 width and height
	** tells us there is no region currently defined
	*/
	ActiveRegion.row = 0;
	ActiveRegion.col = 0;
	ActiveRegion.width = 0;
	ActiveRegion.height = 0;
	RegionFirst = True;
	/*
	** allocate the memory...
	*/
	PixColors = (unsigned long *)malloc(NumRows*NumCols*sizeof(long));
	ColSegs = (XSegment *)malloc(NumColSegs*sizeof(XSegment));
	RowSegs = (XSegment *)malloc(NumRowSegs*sizeof(XSegment));



	dAreaW = (NumCols*(CELLSIZE+1)) + (2*MARGIN);
	dAreaH = (NumRows*(CELLSIZE+1)) + (2*MARGIN);

	display = XtDisplay(toplevel);
	visual  = DefaultVisual(display,DefaultScreen(display));
	cmap = DefaultColormap(display,DefaultScreen(display));
	gridGC = XCreateGC(display,RootWindowOfScreen(XtScreen(toplevel)),
			None,NULL);
	PixmapBackground =  WhitePixel(display,DefaultScreen(display));
	XSetForeground(display,gridGC,
			BlackPixel(display,DefaultScreen(display)));
	CurrentColor = BlackPixel(display,DefaultScreen(display));
	XSetBackground(display,gridGC,PixmapBackground);
	eraseGC = XCreateGC(display,RootWindowOfScreen(XtScreen(toplevel)),
			None,NULL);
	paintGC = XCreateGC(display,RootWindowOfScreen(XtScreen(toplevel)),
			None,NULL);
	highlightGC = XCreateGC(display,RootWindowOfScreen(XtScreen(toplevel)),
			None,NULL);
	XSetForeground(display,highlightGC,str2pix("green"));



	/* create the elements of the main window
	 */
	mainWindow = XmCreateMainWindow(toplevel,"mainWindow",NULL,0);
	XtManageChild(mainWindow);

	/* create the menubar and all of its pulldowns
	 */
	CreateHelpText();
	menuBar = (Widget) CreateMenuBar(mainWindow);

	mainBB = XmCreateForm(mainWindow,"mainBB",NULL,0);
	XtManageChild(mainBB);
	XmMainWindowSetAreas(mainWindow,menuBar,NULL,NULL,NULL,mainBB);

	
	XtSetArg(args[0],XmNdirMask,
			XmStringCreateLtoR("*.pix",XmSTRING_DEFAULT_CHARSET));
	fileDialog =  XmCreateFileSelectionDialog(toplevel,
				"fileDialog",args,1);
	XtAddCallback(fileDialog, XmNcancelCallback, CancelFileCB, NULL);
	XtAddCallback(fileDialog, XmNokCallback,     FileCB, NULL);
	XtAddCallback(fileDialog, XmNunmapCallback,  UnFileCB, NULL);
	
	messageDialog = XmCreateInformationDialog(toplevel,"messageDialog",
				NULL,0);
	cb = XmMessageBoxGetChild(messageDialog,XmDIALOG_CANCEL_BUTTON);
	XtDestroyWidget(cb);
	XtAddCallback(messageDialog, XmNokCallback, killMessage, NULL);


	/* create the working dialog that will pop up when an image is
	 * being processed...
	 */
	XtSetArg(args[0],XmNmessageString, 
		XmStringCreateLtoR("Converting Pixel Values of Captured Image",
				XmSTRING_DEFAULT_CHARSET));
	imageWorking = XmCreateWorkingDialog(toplevel,"imageWorking",args,1);
	cb = XmMessageBoxGetChild(imageWorking,XmDIALOG_CANCEL_BUTTON);
	XtDestroyWidget(cb);

	cb = XmMessageBoxGetChild(imageWorking,XmDIALOG_OK_BUTTON);
	XtDestroyWidget(cb);


	if (NumCols > SWIN_MAX_COLS)
		SWinWidth = SWIN_MAX_WIDTH;
	else
		SWinWidth = dAreaW + SWIN_PAD;
	if (NumRows > SWIN_MAX_ROWS)
		SWinHeight = SWIN_MAX_HEIGHT;
	else
		SWinHeight = dAreaH + SWIN_PAD;

	n = 0;
	XtSetArg(args[n], XmNwidth, SWinWidth); n++;
	XtSetArg(args[n], XmNheight, SWinHeight); n++;
	XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmAS_NEEDED); n++;
	XtSetArg(args[n], XmNscrollingPolicy, XmAUTOMATIC); n++;
	XtSetArg(args[n], XmNscrolledWindowMarginHeight, 10); n++;
	XtSetArg(args[n], XmNscrolledWindowMarginWidth, 10); n++;
	mainSWin = XmCreateScrolledWindow(mainBB,"mainSWin",args,n);
	XtManageChild(mainSWin);

	n = 0;
	XtSetArg(args[n],XmNresizePolicy, XmRESIZE_NONE); n++;
	XtSetArg(args[n], XmNwidth, dAreaW); n++;
	XtSetArg(args[n], XmNheight,dAreaH); n++;
	dArea = XmCreateDrawingArea(mainSWin,"dArea",args,n);
	XtManageChild(dArea);

	XmScrolledWindowSetAreas(mainSWin,NULL,NULL,dArea);



	CreateColorPalette(mainBB);

	/* create the drawing area in a frame in which will be displayed
	 * an actual size version of the pixmap being edited
	 */

	n = 0;
	XtSetArg(args[n],XmNtopAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNtopWidget,colorFrame); n++;
	XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET); n++;
	XtSetArg(args[n],XmNleftWidget,mainSWin); n++;
	XtSetArg(args[n],XmNscrollBarDisplayPolicy,XmAS_NEEDED); n++;
	XtSetArg(args[n],XmNscrollingPolicy,XmAUTOMATIC); n++;
	XtSetArg(args[n],XmNscrolledWindowMarginHeight,10); n++;
	XtSetArg(args[n],XmNscrolledWindowMarginWidth,10); n++;
	XtSetArg(args[n],XmNwidth,280); n++;
	XtSetArg(args[n],XmNheight,200); n++;
	pixViewSW = XmCreateScrolledWindow(mainBB,"pixViewSW",args,n);
	XtManageChild(pixViewSW);

	pixView[0] = XmCreateFrame(pixViewSW,"pixViewFrame",NULL,0);	
	XtManageChild(pixView[0]);
        n = 0;
        XtSetArg(args[n], XmNwidth,NumCols); n++;
        XtSetArg(args[n], XmNheight,NumRows); n++;
	pixView[1] = XmCreateDrawingArea(pixView[0],"pixView",args,2);
	XtManageChild(pixView[1]);

	/*
	 * add the callbacks
	 */
	XtAddCallback(dArea,XmNinputCallback, KeyBtnCB, NULL);
	XtAddCallback(dArea,XmNexposeCallback, exposeCB, NULL);
	XtAddCallback(pixView[1],XmNexposeCallback, pixExposeCB, NULL);


	XtRealizeWidget(toplevel);

	/* now we can do all those things that must be done before we
	 * actually get going but had to wait until after the widget
	 * tree was realized
	 */
	win = XtWindow(dArea);
	pixwin = XtWindow(pixView[1]);
	gridCursor = XCreateFontCursor(display,XC_dot);
	XDefineCursor(display,win,gridCursor);
	lineCursor = XCreateFontCursor(display,XC_pencil);
	XRecolorCursor(display,gridCursor,&(colors[CurrentColor]),
			&(colors[PixmapBackground]));
	changeCursor = XCreateFontCursor(display,XC_exchange);
	regionCursor = XCreateFontCursor(display,XC_dotbox);


	/* set the foreground value of the eraseGC and the background value
	 * of the drawing area window to the same pixel value...white
	 */
	XSetForeground(display,eraseGC,PixmapBackground);
	XSetWindowBackground(display,win,PixmapBackground);

	XSetWindowBackground(display,pixwin,PixmapBackground);
        XtSetArg(args[0], XmNbackground, 
			BlackPixel(display,DefaultScreen(display)));
        XtSetValues(colorPane[1], args, 1);


	/* add the event handler for mouse motion in our drawing area
	 * window
	 */
	XtAddEventHandler(dArea,Button1MotionMask |
				Button2MotionMask |
				Button3MotionMask,
				False,MouseMotionCB,NULL);

	BuildGrid();
	/*
	XtMainLoop();
	*/
	XtUnmanageChild(dialog);
	XtDestroyWidget(dialog);
	XtAppMainLoop(app);
}

void exitCB(w,client,call)
	Widget w;
	caddr_t client, call;
{
	exit(0);
}

BuildGrid()
{
	int i, c, r;
	int ColLen = NumRows*(CELLSIZE+1);
	int RowLen = NumCols*(CELLSIZE+1);
	for (i=0;i<=NumCols;i++) {
		ColSegs[i].x1 = ColSegs[i].x2 = i*(CELLSIZE+1)+MARGIN;
		ColSegs[i].y1 = MARGIN;
		ColSegs[i].y2 = MARGIN + ColLen;
	}
	for (i=0;i<=NumRows;i++) {
		RowSegs[i].y1 = RowSegs[i].y2 = i*(CELLSIZE+1)+MARGIN;
		RowSegs[i].x1 = MARGIN;
		RowSegs[i].x2 = MARGIN + RowLen;
		/* this little loop is to init the PixColor array with all
		 * zeros
		 */
	}
	for (r=0;r<NumRows;r++)
		for(c=0;c<NumCols;c++)
			PixColors[r*NumCols+c] = PixmapBackground;
			
}
		
		

void DrawGrid(w,client,call)
	Widget w;
	caddr_t client, call;
{
	XDrawSegments(display,win,gridGC,ColSegs,NumCols+1);
	XDrawSegments(display,win,gridGC,RowSegs,NumRows+1);
}


void KeyBtnCB(w,client,call)
	Widget w;
	caddr_t client;
	XmDrawingAreaCallbackStruct  *call;
{
	int row, column, pixel;
	Arg args[3];
	static int ColorToChange, TargetColor;
	XColor fg, bg;

	if ((call->event->xbutton.x < MARGIN)            ||
	    (call->event->xbutton.y < MARGIN)            ||
	    (call->event->xbutton.x > (dAreaW - MARGIN)) ||
	    (call->event->xbutton.y > (dAreaH - MARGIN))) 
		return;

	if (call->event->type != ButtonRelease)
		return;

	getRC(&row,&column,call->event->xbutton.x,
		call->event->xbutton.y);
	pixel = row*NumCols+column;	
	switch (call->event->xbutton.button) {
	case Button1:
		switch (DrawState) {
		case NOOP:
			PixColors[pixel] = CurrentColor;
			XSetForeground(display,paintGC,CurrentColor);
			XFillRectangle(display,win,
				paintGC,
				ColSegs[column].x1+1,RowSegs[row].y1+1,
				CELLSIZE,CELLSIZE);
			XDrawPoint(display,pixwin,
				paintGC,column,row);
			break;
		case REGION:
			/* we're here because the user selected 
			** MARK region from the region menu and has
			** now clicked on a cell. our task here is
			** to grab the row,col and wait for next
			** button click
			*/
			switch (RegionOp) {
			case MARK_R:
				if (RegionFirst) {
			    		ActiveRegion.row = row;
			    		ActiveRegion.col = column;
			    		highlightCell(ActiveRegion.row,
						ActiveRegion.col);
			    		RegionFirst = False;
				}
				else /* RegionFirst is False */
			    		handleRegion(call,row,column);
				break;
			case COPY_R:
				copyRegion(ActiveRegion,row,column);
				RegionOp = NOOP;
				XDefineCursor(display,win,gridCursor);
				DrawState = NOOP;
				break;
			}
			break;
		default:	
			handleGraphics(call);
			break;
		}
		break;
	case Button2:
		PixColors[pixel] = PixmapBackground;
		XFillRectangle(display,win,eraseGC,
			ColSegs[column].x1+1,RowSegs[row].y1+1,
			CELLSIZE,CELLSIZE);
		XDrawPoint(display,pixwin,eraseGC,column,row);
		break;
	case Button3:
		switch (ColorChangeMode) {
		case 0:		/* NOT in ColorChangeMode */
			CurrentColor = PixColors[pixel];
			fg.pixel = CurrentColor;
			bg.pixel = BlackPixel(display,DefaultScreen(display));
			XQueryColor(display,cmap,&fg);
			XQueryColor(display,cmap,&bg);
       			XRecolorCursor(display,gridCursor,&fg,&bg);
			XtSetArg(args[0], XmNbackground,fg.pixel);
			XtSetValues(colorPane[1], args, 1);
			break;
		case 2:	
			/* get the color, change the colors, then
			 * change the cursor back to normal
			 */
			ColorToChange = PixColors[pixel];
			GlobalColorChange(ColorToChange);
			ColorChangeMode = 0;
			XDefineCursor(display,win,gridCursor);
			break;
		}
		break;
	}
}

GlobalColorChange(from,to)
	int from, to;
{
/* change all instances of the pixel value 'from' to the CurrentColor 
 */
	int r, c;
	int p;

	for (r=0;r<NumRows;r++)
		for(c=0;c<NumCols;c++) {
			 p = r*NumCols+c;
			if (PixColors[p] == from) {
				PixColors[p] = CurrentColor;
				XSetForeground(display,paintGC,CurrentColor);
				XFillRectangle(display,win,
					paintGC,
					ColSegs[c].x1+1,RowSegs[r].y1+1,
					CELLSIZE,CELLSIZE);
				XDrawPoint(display,pixwin,paintGC,c,r);
			}
		}
}


handleGraphics(call)
	XmDrawingAreaCallbackStruct  *call;
{
/* this function only gets called if there was a Button1 press
 * in  the grid area when DrawState is set to something other than
 * NOOP... the graphics that will be called will be line, rect,
 * filled rect, circle and filled circle. in all of these cases,
 * the first button pressed simply marks the beginning cell of
 * the graphics...
 */
	int row, column;
	int pixel;
	static int startRow, startCol;
	int x1, y1, x2, y2;
	getRC(&row,&column,call->event->xbutton.x,
			call->event->xbutton.y);
	pixel = row*NumCols+column;	
	if (FirstPoint) {
		startRow = row;
		startCol = column;
		FirstPoint = False;
		setCell(startCol,startRow);
	}
	else {
		switch (DrawState) {
		case LINE:
			drawLine(startCol,startRow,column,row);
			FirstPoint = True;
			DrawState = NOOP;
			XDefineCursor(display,win,gridCursor);
			break;
		case RECT:
			break;
		case FRECT:
			break;
		case CIRC:
			break;
		case FCIRC:
			break;
		}
	}
}


void MouseMotionCB(w,client,event)
	Widget w;
	caddr_t client;
	XPointerMovedEvent *event;
{
	int row, column, pixel;

	/* make sure that the event was in the grid
	 */
	if ((event->x < MARGIN)            ||
	    (event->y < MARGIN)            ||
	    (event->x > (dAreaW - MARGIN)) ||
	    (event->y > (dAreaH - MARGIN))) 
		return;

	getRC(&row,&column,event->x,event->y);
	pixel = row*NumCols+column;	
	switch (event->state) {
	case Button1Mask:
		PixColors[pixel] = CurrentColor;
		XSetForeground(display,paintGC,CurrentColor);
		XFillRectangle(display,win,paintGC,
			ColSegs[column].x1+1,RowSegs[row].y1+1,
			CELLSIZE,CELLSIZE);
		XDrawPoint(display,pixwin,paintGC,column,row);
		break;
	case Button2Mask:
		PixColors[pixel] = PixmapBackground;
		XFillRectangle(display,win,eraseGC,
			ColSegs[column].x1+1,RowSegs[row].y1+1,
			CELLSIZE,CELLSIZE);
		XDrawPoint(display,pixwin,eraseGC,column,row);
		break;
	}
}


void pixExposeCB(w,client,call)
	Widget w;
	caddr_t client;
	XmDrawingAreaCallbackStruct  *call;
{
	int x, y, p;
	int startX, startY;
	int width, height;
	if (Virgin == False) {
		startX = call->event->xexpose.x;
		startY = call->event->xexpose.y;
		width = call->event->xexpose.width ;
		height = call->event->xexpose.height ;
		for (y=startY;y<startY+height;y++)
			for(x=startX;x<startX+width;x++) {
				p = y*NumCols+x;	
				XSetForeground(display,paintGC,PixColors[p]);
				XDrawPoint(display,pixwin,paintGC,x,y);
			}
	}
}

void exposeCB(w,client,call)
	Widget w;
	caddr_t client;
	XmDrawingAreaCallbackStruct  *call;
{
	int i, startX, startY, stopX, stopY, 
	    startPixel, stopPixel, row, column;
	int x, y, exposeX, exposeY, exposeWidth, exposeHeight;
	int p, LastColor = -1;
	int r1, c1;

	/* is this the exposure from the first mapping?
	 */
	if ((Virgin == True) && (call->event->xexpose.count > 0)) 
		/* ignore the event */; 
	else if ((Virgin == True) && (call->event->xexpose.count == 0)) {
		/* this is the last of the first, so I can set Virgin
		 * to false and draw the grid-- when I get to the point
		 * of reading in files, this is the place to put in the
		 * actual drawing routines
		 */
		XDrawSegments(display,win,gridGC,ColSegs,NumCols+1);
		XDrawSegments(display,win,gridGC,RowSegs,NumRows+1);
		Virgin = False;
	}
	else {
		XDrawSegments(display,win,gridGC,ColSegs,NumCols+1);
		XDrawSegments(display,win,gridGC,RowSegs,NumRows+1);
	 	
		startX = call->event->xexpose.x;
		startY = call->event->xexpose.y;

		if (startX <= ColSegs[0].x1)
			startX = ColSegs[0].x1 + 1;
		else if (startX >= ColSegs[NumCols].x1)
			return;
		if (startY <= RowSegs[0].y1)
			startY = RowSegs[0].y1 + 1;
		else if (startY >= RowSegs[NumRows].y1)
			return;

		exposeX = startX;
		exposeY = startY;
		exposeWidth = call->event->xexpose.width;
		exposeHeight = call->event->xexpose.height;

		if ((exposeWidth+exposeX+CELLSIZE) > ColSegs[NumCols].x1)
			exposeWidth = ColSegs[NumCols].x1-1;
		else 
			exposeWidth = exposeWidth+exposeX+CELLSIZE; 
		if ((exposeHeight+exposeY+CELLSIZE) > RowSegs[NumRows].y1)
			exposeHeight = RowSegs[NumRows].y1-1;
		else 
			exposeHeight = exposeHeight+exposeY+CELLSIZE;

		for (y=exposeY;y<exposeHeight;y+=(CELLSIZE)) { 
			for(x=exposeX;x<exposeWidth;x+=(CELLSIZE)){
				getRC(&row,&column,x,y);
				p = row*NumCols+column;	
				if (PixColors[p] ==  PixmapBackground)
					continue;
				XSetForeground(display,paintGC,PixColors[p]);
				XFillRectangle(display,win,
					paintGC,
					ColSegs[column].x1+1,RowSegs[row].y1+1,
					CELLSIZE,CELLSIZE);
				XDrawPoint(display,pixwin,paintGC,column,row);
			}
		}
		if (ActiveRegion.width > 0 && ActiveRegion.height > 0)
			highlightRegion(ActiveRegion);
	}
}

redrawPixmap(StartRow,StartCol,width,height)
	int StartRow,
	    StartCol,
	    width,
	    height;
{
	int i, col, row;
	int last = -1;
	for (row = StartRow;row<StartRow+height;row++)
		for (col = StartCol;col<StartCol+width;col++) {
			i = row*NumCols+col;
			XSetForeground(display,paintGC,PixColors[i]);
			XFillRectangle(display,win,paintGC,
				ColSegs[col].x1+1,RowSegs[row].y1+1,
				CELLSIZE,CELLSIZE);
			XDrawPoint(display,pixwin,paintGC,col,row);
		}
}

redrawFromPixmap(p,width,height)
	Pixmap p;
	int    width,
	       height;
{
	XImage *xim;
	int i, x, row, col;

	/*
	** since i am now using the "standard" xpm format for input and
	** output, i have to take the pixmap that xpm_read gives me,
	** suck an image out of it, go through each pixel and paint the
	** appropriate rectangle in the grid. if you were writing this
	** so that you knew you would always be working with an 8 bit
	** display, you can access the data elements directly in the
	** memory pointed to by the 'data' field of the XImage structure.
	** but, since this is "portable", i use the generic Xlib routine
	** XGetPixel...
	*/

	xim = XGetImage(display,p,0,0,width,height,AllPlanes,ZPixmap);
	if (width > NumCols)
		width = NumCols;
	if (height > NumRows)
		height = NumRows;
	for (row=0,x=0;row<height;row++,x+=NumCols) {
		for (col=0;col<width;col++) {
			i = x+col;
			PixColors[i] = XGetPixel(xim,col,row);
			XSetForeground(display,paintGC,PixColors[i]);
			XFillRectangle(display,win,paintGC,
					ColSegs[col].x1+1,
					RowSegs[row].y1+1,
					CELLSIZE,CELLSIZE);
		}
	}
	XPutImage(display,pixwin,paintGC,xim,0,0,0,0,width,height);
}



void selectColorCB(w,client,call)
	Widget w;
	int client; 
	caddr_t call;
{
	Arg args[5];

	/*
	** CurrentColor = client;	
	**
	** that was the way it was, but now i'm using the colormap
	** pixel values...
	*/
	CurrentColor = colors[client].pixel;

	XRecolorCursor(display,gridCursor,&(colors[client]),
		&(colors[PixmapBackground]));
	
	/*
        ** XtSetArg(args[0], XmNbackground, colors[CurrentColor].pixel);
	*/ 
	XtSetArg(args[0], XmNbackground, CurrentColor);
        XtSetValues(colorPane[1], args, 1);
	XFlush(display);
}	

getRC(row,column,x,y)
	int *row, *column;
	int x, y;
{
	int r, c, found = 0;
	c = 0;
	while (!found) {
		if ((x >= ColSegs[c].x1) && 
		   (x <= ColSegs[c+1].x1))
			found = 1;
		else
			c++;
	}
	found = 0;
	r= 0;
	while (!found) {
		if ((y >= RowSegs[r].y1) &&
	   	   (y <= RowSegs[r+1].y1))
			found = 1;
		else
			r++;
	}
	*column = c;
	*row    = r;
}



setCell(col,row)
	int col, row;
{
	int p = row*NumCols+col;	
	PixColors[p] = CurrentColor;
	XSetForeground(display,paintGC,CurrentColor);
	XFillRectangle(display,win,paintGC,
			ColSegs[col].x1+1,RowSegs[row].y1+1,
			CELLSIZE,CELLSIZE);
	XDrawPoint(display,pixwin,paintGC,col,row);
}

Pixel str2pix(spec)
	char *spec;     /* color name */
{
	XColor color_struct;
	
	if (!XParseColor(display, cmap, spec, &color_struct))
		return((Pixel)0);
	if (!XAllocColor(display, cmap, &color_struct)) 
		return((Pixel)0);
	else
		return(color_struct.pixel);
}


ForceUpdate(w,cxt)
Widget w;
XtAppContext cxt;
{
	Widget diashell, topshell;
	Window diawindow, topwindow;
	Display *dpy;
	XWindowAttributes xwa;
	XEvent event;

	for (diashell=w;!XtIsShell(diashell);
		diashell=XtParent(diashell));
	for (topshell=diashell;!XtIsTopLevelShell(topshell);
		topshell=XtParent(topshell));
	if (XtIsRealized(diashell) && XtIsRealized(topshell)) {
		dpy = XtDisplay(topshell);
		diawindow =XtWindow(diashell);
		topwindow = XtWindow(topshell);
		while (XGetWindowAttributes(dpy,diawindow,&xwa) &&
			xwa.map_state != IsViewable) {
			if (XGetWindowAttributes(dpy,topwindow,&xwa) &&
				xwa.map_state != IsViewable)
				break;
			XtAppNextEvent(cxt,&event);
			XtDispatchEvent(&event);
		}
	}
	XmUpdateDisplay(topshell);
}
